package com.acme.trainings.rs.mappers;

import com.acme.trainings.domain.model.Author;
import com.acme.trainings.domain.model.Book;
import com.acme.trainings.rs.model.AuthorWithoutBooks;
import com.acme.trainings.rs.model.BookDetailItem;
import com.acme.trainings.rs.model.BookListItem;
import org.mapstruct.Mapper;
import org.mapstruct.Mapping;

@Mapper(componentModel = "cdi")
public interface BookMapper {

    //Here we tell mapstruct, that we want to map Book.author = ur Author entity, into authorname which is string
    //we have to therefore tell it how it can be done - see authorToAuthorName bellow
    //when mapstruct will try to map book entity, it it gets to the author, it will search for any method, that can convert Author object
    //to string, and it will find the method bellow which we wrote by hand
    @Mapping(source = "author.name", target = "authorName")
    BookListItem map(Book book);


    //use @Mapping to customize source->target mapping, e.g. in this case the tags are called bookTags in teh dto
    @Mapping(source = "tags", target = "bookTags")
    BookDetailItem mapToDetail(Book book);

    //note: in newer java, we can add methods to interfaces using 'default' keyword
    //this has nothing to do with mapstruct, its just a standard java method, that takes Author
    //and returns its name
    //this shows how mapstruct autogenerated methods can used together with hand written ones
    default String mapAuthorToAuthorName(Author a) {
        return a.getName();
    }

    //This would be used by mapToDetail method, when Mapstruct wants to map Book.author to BookDetailItem.author
    AuthorWithoutBooks map(Author author);
}
